import { TableColumnsType } from "antd";
import { Lesson } from "../../types/Item";
import { FaPlus } from "react-icons/fa";
import useModalHandler from "../../utils/useModalHandler";
import { ModalEnum } from "../../enums/Model";
import { useObjectToEdit } from "../../zustand/ObjectToEditState";
import { useTranslation } from "react-i18next";
import { ABILITIES_ENUM } from "../../enums/abilities";
import { useNavigate } from "react-router-dom";
import {
  canAddLesson,
  canDeleteLesson,
  canEditLesson,
  canShowLesson,
} from "../../utils/hasAbilityFn";
import ActionButtons from "../../Components/Table/ActionButtons";

export const useColumns = () => {
  const { handel_open_model } = useModalHandler();

  const { setObjectToEdit } = useObjectToEdit((state) => state);
  const navigate = useNavigate();

  const handelShow = (record: any) => {
    navigate(`${ABILITIES_ENUM.LESSON}/${record?.id}`);
  };

  const handelDelete = (data: any) => {
    setObjectToEdit(data);
    handel_open_model(ModalEnum?.LESSON_DELETE);
  };

  const handleEdit = (record: any) => {
    setObjectToEdit(record);
    handel_open_model(ModalEnum?.LESSON_EDIT);
  };
  const [t] = useTranslation();

  const columns: TableColumnsType<Lesson> = [
    {
      title: t("columns.id"),
      dataIndex: "id",
      key: "id",
      align: "center",
      render: (text, record) => record?.id,
    },
    {
      title: `${t("columns.name")}`,
      dataIndex: "name",
      key: "name",
      align: "center",
      render: (text, record) => record?.name,
    },
    {
      title: canAddLesson ? (
        <button
          onClick={() => handel_open_model(ModalEnum?.LESSON_ADD)}
          className="add_button"
        >
          {t("practical.add")} {t("models.lesson")} <FaPlus />
        </button>
      ) : (
        ""
      ),
      key: "actions",
      align: "end",
      width: "25vw",
      render: (_text, record, index) => {
        return (
          <ActionButtons
            canDelete={canDeleteLesson}
            canEdit={canEditLesson}
            canShow={canShowLesson}
            index={index}
            onDelete={() => handelDelete(record)}
            onEdit={() => handleEdit(record)}
            onShow={() => handelShow(record)}
          />
        );
      },
    },
  ];

  return columns;
};
